	include	whdload.i
	include	whdmacros.i

; ====== Header ======
_base		SLAVE_HEADER				;ws_Security + ws_ID
		dc.w	17				;ws_Version
		dc.w	WHDLF_NoError!WHDLF_EmulTrap  	;ws_flags
		dc.l	512*1024                        ;ws_BaseMemSize
		dc.l	0				;ws_ExecInstall
		dc.w	start-_base			;ws_GameLoader
		dc.w	0				;ws_CurrentDir
		dc.w	0				;ws_DontCache
_keydebug	dc.b	0				;ws_keydebug
_keyexit	dc.b	$59				;ws_keyexit = F10
_expmem		dc.l	0                          	;ws_ExpMem
		dc.w	_name-_base			;ws_name
		dc.w	_copy-_base			;ws_copy
		dc.w	_info-_base			;ws_info
		dc.w    0    				;kickstart name
		dc.l    $0      			;kicksize
		dc.w    $0      			;kickcrc
    		dc.w    _config-_base
_config
		dc.b	0
_name	dc.b	"CP/M-68K",0
_copy	dc.b	"DEC",0
_info	dc.b	"Version 0.2",10
	dc.b	0
        even

; Reuse track buffer
sound=$67b5a
nullsound=sound
bellsound=sound+2


start   ;A0 = resident loader
        move.l  a0,a2
	lea	_resload(pc),a0
	move.l	a2,(a0)

        lea	tags(pc),a0
        jsr	resload_Control(a2)

        move.l  #$400,d0        ; offset (in bytes)
        move.l  #$7c00,d1       ; size (in bytes)
        moveq   #1,d2           ; disk number
        move.l  #$60000,a0      ; destination address
        jsr     resload_DiskLoad(a2)

        lea     pl_bios(pc),a0
        move.l  #$66000,a1
        jsr     resload_Patch(a2)

        jmp     $60000

biosbase=$15a

pl_bios PL_START
        ; Skip floppy init code
        PL_NOP  $022,4
        ;PL_NOP  $050,12
        PL_PSS  $50,init,6

        PL_PA   biosbase+$0d*4,readsector
        PL_PA   biosbase+$0e*4,writesector
        PL_PA   biosbase+$15*4,flush

        PL_PS   $24c,bell
        PL_END

init
        clr.w   nullsound
        lea     belldata(pc),a0
        lea     bellsound,a1
        move.w  #belldatasize/4-1,d0
.copysound
        move.l  (a0)+,(a1)+
        dbf     d0,.copysound

        lea     vertb(pc),a0
        move.l  a0,$6c.w
        move.w  #INTF_SETCLR!INTF_VERTB,intena(a6)

        ;REPT    4
        ;moveq   #7,d1
        ;jsr     $066220 ;conout
        ;ENDR

        rts

vertb
        movem.l d0-d1/a0-a1,-(sp)
        lea     $dff000,a0

        move.l  custom1(pc),d1
        subq.l  #1,d1
        bmi     .nowait
.wait1
        move.b  vhposr(a0),d0
.wait2
        cmp.b   vhposr(a0),d0
        beq     .wait2
        dbf     d1,.wait1

.nowait
        move.w  #INTF_VERTB,intreq(a0)
        move.w  #INTF_VERTB,intreq(a0)
        movem.l (sp)+,d0-d1/a0-a1
        rte


WAIT_AUD0       MACRO
.\@             btst.b  #INTB_AUD0,intreqr+1(a0)
                beq     .\@
                move.w  #INTF_AUD0,intreq(a0)
                ENDM
bell
        cmp.b   #7,d1
        bne     .out

        lea     $dff000,a0
        move.w  #INTF_VERTB,intena(a0) ; disable slowdown while beeping

        move.w  #INTF_AUD0,intreq(a0)
        move.w  #$40,aud0+ac_vol(a0)
        move.w  #322,aud0+ac_per(a0)
        move.w  #belldatasize/2,aud0+ac_len(a0)
        move.l  #bellsound,aud0+ac_ptr(a0)
        move.w  #DMAF_SETCLR!DMAF_AUD0,dmacon(a0)
        WAIT_AUD0
        move.w  #1,aud0+ac_len(a0)
        move.l  #nullsound,aud0+ac_ptr(a0)
        WAIT_AUD0
        move.w  #DMAF_AUD0,dmacon(a0)

        move.w  #INTF_SETCLR!INTF_VERTB,intena(a0)
.out
        ; orig code
	lea     $06640e,a0
        moveq   #0,d0
        rts


cpm_track=$67036        ; word
cpm_sector=$67038       ; word
cpm_dma=$6703a          ; pointer

readsector
        movem.l d0-d2/a0-a2,-(sp)
        move.w  cpm_track,d0
        mulu.w  #512*11,d0
        moveq   #0,d1
        move.w  cpm_sector,d1
        lsl.w   #7,d1
        add.l   d1,d0           ; offset (in bytes)
        move.l  #128,d1         ; size (in bytes)
        moveq   #1,d2           ; disk number
        move.l  cpm_dma,a0      ; destination address
        move.l  _resload(pc),a2
        jsr     resload_DiskLoad(a2)
        movem.l (sp)+,d0-d2/a0-a2
        clr.w   d0 ; no error
        rts

writesector
        blitz
        bra     writesector

flush
        clr.w   d0 ; no error
        rts

tags
	        dc.l	WHDLTAG_CUSTOM1_GET
custom1         dc.l	0
	        dc.l	WHDLTAG_CUSTOM2_GET
custom2         dc.l	0
	        dc.l	0

_resload
                ds.l    1


belldata
                incbin bell.raw
                cnop 0,4
belldatasize=*-belldata
